FROM nvidia/cuda:10.1-cudnn7-runtime-ubuntu18.04

## config
ARG USER=zehe
ARG UID=1052
# set to 1 to install conda:
ARG INSTALL_CONDA=1

# insertion from Barth/Doenicke
SHELL ["/bin/bash", "-c"]
# end of insertion from Barth/Doenicke

## setup
RUN touch `date` && apt-get update
RUN apt install python3 python3-pip python3-dev python3-venv zsh byobu htop vim git wget lsof fuse parallel rsync -y

RUN mkdir /docker_home

RUN adduser ${USER} --uid ${UID} --home /docker_home/ls6/${USER}/ --disabled-password --gecos "" --no-create-home
RUN mkdir -p /docker_home/ls6/${USER}
RUN chown -R ${USER} /docker_home/ls6/${USER}

RUN mkdir -p /pip
RUN chown -R ${USER} /pip


USER ${UID}


RUN python3 -m venv /pip

# insertion from Barth/Doenicke
ADD requirements.txt .
RUN source /pip/bin/activate && pip3 install -r requirements.txt

#ADD predict.py .

WORKDIR /docker_home/ls6/zehe/
ADD wikt ./wikt
ADD install_nltk.py .
ADD words.dg .

RUN source /pip/bin/activate && \
    # spaCy
    python3 -m spacy download de_core_news_lg
RUN source /pip/bin/activate && \
    # DEMorphy
    git clone https://github.com/DuyguA/DEMorphy && \
    cd DEMorphy && \
    cp ../words.dg demorphy/data/words.dg && \
    python3 setup.py install && \
    cp demorphy/data/words.dg /pip/lib/python3.6/site-packages/demorphy-1.0-py3.6.egg/demorphy/data/ && \
    cd .. && \
    # NeuralCoref
    git clone https://github.com/huggingface/neuralcoref.git && \
    cd neuralcoref && \
    pip install -e . && \
    cd .. && \
    # Extended Open Multilingual Wordnet
    python3 install_nltk.py && \
    mkdir ~/nltk_data/corpora/omw/deu && \
    cp ./wikt/wn-wikt-deu.tab ~/nltk_data/corpora/omw/deu/wn-data-deu.tab

ADD code /code
ADD data /data

#RUN source /pip/bin/activate && \
#    python3 -u predict.py

# end of insertion from Barth/Doenicke


ENV PYTHONUNBUFFERED=1
ENV LANG C.UTF-8
ENV LC_ALL C.UTF-8


USER 0

RUN if [ "${INSTALL_CONDA}" = "1" ]; then bash -c 'mkdir /conda && chown ${UID} /conda && \
\
cd /conda && \
/bin/bash -c "wget http://repo.continuum.io/miniconda/Miniconda-latest-Linux-x86_64.sh -O ./miniconda.sh" && \
chmod 0755 ./miniconda.sh && \
/bin/bash -c "./miniconda.sh -b -p ./conda" && \
\
ln -s "/conda/conda/bin/conda" "/usr/local/bin/conda" && \
rm ./miniconda.sh && \
\
chown -R ${UID} /conda'; \
fi


RUN mkdir -p /data/train
RUN mkdir -p /data/test

RUN mkdir -p /predictions
RUN mkdir -p /code

RUN chown -R ${USER} /data
RUN chown -R ${USER} /predictions
RUN chown -R ${USER} /code
RUN chown -R ${USER} /docker_home/ls6/zehe
RUN chown ${USER} /

USER ${UID}

ADD predict.py /
ADD eval.py /

ENTRYPOINT bash -c "source /pip/bin/activate && python /predict.py && python /eval.py"